### Function Macro

# Atk DEFINE_ABSTRACT_TYPE_WITH_CODE

since: 1.22

#### Declaration [src]

    #define ATK_DEFINE_ABSTRACT_TYPE_WITH_CODE (
      TN,
      t_n,
      T_P,
      _C_
    )

#### Description [src]

A convenience macro for ATK type implementations. Similar to ATK_DEFINE_TYPE_WITH_CODE(), but defines an abstract type.

Available since: 1.22

This function is not directly available to language bindings.

#### Parameters

`TN`

  Type: `-`

  The name of the new type, in Camel case.

`t_n`

  Type: `-`

  The name of the new type, in lowercase, with words separated by ‘_’.

`T_P`

  Type: `-`

  The `GType` of the parent type.

`_C_`

  Type: `-`

  Custom code that gets inserted in the _get_type() function.